Index: /trunk/src/world_entities/npcs/ground_turret.h
===================================================================
--- /trunk/src/world_entities/npcs/ground_turret.h	(revision 7953)
+++ /trunk/src/world_entities/npcs/ground_turret.h	(revision 7954)
@@ -30,7 +30,4 @@
   virtual void tick(float time);
 
-  virtual int writeBytes(const byte* data, int length, int sender);
-  virtual int readBytes(byte* data, int maxLength, int * reciever);
-
  private:
    PNode  weaponHolder[2];
Index: /trunk/src/world_entities/playable.cc
===================================================================
--- /trunk/src/world_entities/playable.cc	(revision 7953)
+++ /trunk/src/world_entities/playable.cc	(revision 7954)
@@ -62,8 +62,10 @@
 
   this->score = 0;
-  this->oldScore = 0;
   this->collider = NULL;
 
   this->bDead = false;
+
+  registerVar( new SynchronizeableInt( &score, &score, "score" ) );
+  registerVar( new SynchronizeableBool( &bFire, &bFire, "bFire", PERMISSION_OWNER));
 }
 
@@ -484,79 +486,4 @@
 
 
-#define DATA_FLAGS    1
-#define DATA_SCORE    2
-
-#define FLAGS_bFire   1
-
-int Playable::writeSync( const byte * data, int length, int sender )
-{
-  SYNCHELP_READ_BEGIN();
-
-  byte b;
-  SYNCHELP_READ_BYTE( b, NWT_PL_B );
-
-  byte flags;
-
-  if ( b == DATA_FLAGS )
-  {
-    SYNCHELP_READ_BYTE( flags, NWT_PL_FLAGS );
-
-    bFire = (flags & FLAGS_bFire) != 0;
-
-    return SYNCHELP_READ_N;
-  }
-
-  if ( b == DATA_SCORE )
-  {
-    int newScore;
-    SYNCHELP_READ_BYTE( newScore, NWT_PL_SCORE );
-    setScore( newScore );
-
-    return SYNCHELP_READ_N;
-  }
-
-  return SYNCHELP_READ_N;
-}
-
-int Playable::readSync( byte * data, int maxLength )
-{
-  SYNCHELP_WRITE_BEGIN();
-
-  if ( score != oldScore && isServer() )
-  {
-    SYNCHELP_WRITE_BYTE( DATA_SCORE, NWT_PL_B);
-    SYNCHELP_WRITE_INT( score, NWT_PL_SCORE );
-    oldScore = score;
-
-    return SYNCHELP_WRITE_N;
-  }
-
-  byte flags = 0;
-
-  if ( bFire )
-    flags |= FLAGS_bFire;
-
-
-  SYNCHELP_WRITE_BYTE( DATA_FLAGS, NWT_PL_B);
-  SYNCHELP_WRITE_BYTE( flags, NWT_PL_FLAGS );
-  oldFlags = flags;
-
-
-  return SYNCHELP_WRITE_N;
-}
-
-bool Playable::needsReadSync( )
-{
-  if ( score != oldScore && isServer() )
-    return true;
-
-  byte flags = 0;
-
-  if ( bFire )
-    flags |= FLAGS_bFire;
-
-  return flags!=oldFlags;
-}
-
 
 /**
Index: /trunk/src/world_entities/playable.h
===================================================================
--- /trunk/src/world_entities/playable.h	(revision 7953)
+++ /trunk/src/world_entities/playable.h	(revision 7954)
@@ -81,10 +81,4 @@
   virtual void tick(float dt);
 
-  // NETWORK
-  int       writeSync(const byte* data, int length, int sender);
-  int       readSync(byte* data, int maxLength );
-  bool      needsReadSync();
-
-
   // Transformations:
   static Playable::Playmode stringToPlaymode(const std::string& playmode);
@@ -115,6 +109,5 @@
   int                   oldFlags;           //!< Used for synchronisation
 
-  int                   score;
-  int                   oldScore;
+  int                   score;              //!< players score
 
   bool                  bDead;
Index: /trunk/src/world_entities/power_ups/laser_power_up.cc
===================================================================
--- /trunk/src/world_entities/power_ups/laser_power_up.cc	(revision 7953)
+++ /trunk/src/world_entities/power_ups/laser_power_up.cc	(revision 7954)
@@ -120,40 +120,3 @@
 }
 
-int LaserPowerUp::writeBytes( const byte * data, int length, int sender )
-{
-  setRequestedSync( false );
-  setIsOutOfSync( false );
 
-  SYNCHELP_READ_BEGIN();
-
-  SYNCHELP_READ_FKT( PowerUp::writeState, NWT_LPU_WE_STATE );
-
-  return SYNCHELP_READ_N;
-}
-
-
-
-int LaserPowerUp::readBytes( byte * data, int maxLength, int * reciever )
-{
-  if ( isOutOfSync() && !requestedSync() && this->getHostID()!=this->getOwner() )
-  {
-    (NetworkGameManager::getInstance())->sync( this->getUniqueID(), this->getOwner() );
-    setRequestedSync( true );
-  }
-
-  int rec = this->getRequestSync();
-  if ( rec > 0 )
-  {
-    *reciever = rec;
-
-    SYNCHELP_WRITE_BEGIN();
-
-    SYNCHELP_WRITE_FKT( PowerUp::readState, NWT_LPU_WE_STATE );
-
-    return SYNCHELP_WRITE_N;
-  }
-
-  *reciever = 0;
-  return 0;
-}
-
Index: /trunk/src/world_entities/power_ups/laser_power_up.h
===================================================================
--- /trunk/src/world_entities/power_ups/laser_power_up.h	(revision 7953)
+++ /trunk/src/world_entities/power_ups/laser_power_up.h	(revision 7954)
@@ -26,7 +26,4 @@
   virtual void draw() const;
 
-  virtual int writeBytes(const byte* data, int length, int sender);
-  virtual int readBytes(byte* data, int maxLength, int * reciever );
-
   private:
    void init();
Index: /trunk/src/world_entities/power_ups/param_power_up.cc
===================================================================
--- /trunk/src/world_entities/power_ups/param_power_up.cc	(revision 7953)
+++ /trunk/src/world_entities/power_ups/param_power_up.cc	(revision 7954)
@@ -43,4 +43,9 @@
   if( root != NULL)
     this->loadParams(root);
+  
+  registerVar( new SynchronizeableInt( (int*)&type, (int*)&type, "type" ) );
+  registerVar( new SynchronizeableFloat( &value, &value, "value" ) );
+  registerVar( new SynchronizeableFloat( &max_value, &max_value, "max_value" ) );
+  registerVar( new SynchronizeableFloat( &min_value, &min_value, "min_value" ) );
 }
 
@@ -119,62 +124,2 @@
 }
 
-int ParamPowerUp::writeBytes( const byte * data, int length, int sender )
-{
-  setRequestedSync( false );
-  setIsOutOfSync( false );
-
-  SYNCHELP_READ_BEGIN();
-
-  SYNCHELP_READ_FKT( PowerUp::writeState, NWT_PPU_WE_STATE );
-
-  int i;
-  SYNCHELP_READ_INT( i, NWT_PPU_TYPE );
-  this->type = (EnumParamPowerUpType)i;
-  SYNCHELP_READ_FLOAT( this->value, NWT_PPU_VALUE );
-
-  if ( this->value != 0 )
-  {
-    SYNCHELP_READ_FLOAT( this->min_value, NWT_PPU_MINVALUE );
-    SYNCHELP_READ_FLOAT( this->max_value, NWT_PPU_MAXVALUE );
-    respawn();
-  }
-
-  return SYNCHELP_READ_N;
-}
-
-
-
-int ParamPowerUp::readBytes( byte * data, int maxLength, int * reciever )
-{
-  if ( isOutOfSync() && !requestedSync() && this->getHostID()!=this->getOwner() )
-  {
-    (NetworkGameManager::getInstance())->sync( this->getUniqueID(), this->getOwner() );
-    setRequestedSync( true );
-  }
-
-  int rec = this->getRequestSync();
-  if ( rec > 0 )
-  {
-    *reciever = rec;
-
-    SYNCHELP_WRITE_BEGIN();
-
-    SYNCHELP_WRITE_FKT( PowerUp::readState, NWT_PPU_WE_STATE );
-
-    int i = (int)this->type;
-    SYNCHELP_WRITE_INT( i, NWT_PPU_TYPE );
-    SYNCHELP_WRITE_FLOAT( this->value, NWT_PPU_VALUE );
-
-    if ( this->value != 0 )
-    {
-      SYNCHELP_WRITE_FLOAT( this->min_value, NWT_PPU_MINVALUE );
-      SYNCHELP_WRITE_FLOAT( this->max_value, NWT_PPU_MAXVALUE );
-    }
-
-    return SYNCHELP_WRITE_N;
-  }
-
-  *reciever = 0;
-  return 0;
-}
-
Index: /trunk/src/world_entities/power_ups/param_power_up.h
===================================================================
--- /trunk/src/world_entities/power_ups/param_power_up.h	(revision 7953)
+++ /trunk/src/world_entities/power_ups/param_power_up.h	(revision 7954)
@@ -32,7 +32,4 @@
   float getValue();
 
-  virtual int writeBytes(const byte* data, int length, int sender);
-  virtual int readBytes(byte* data, int maxLength, int * reciever );
-
 protected:
   virtual void respawn();
Index: /trunk/src/world_entities/power_ups/power_up.cc
===================================================================
--- /trunk/src/world_entities/power_ups/power_up.cc	(revision 7953)
+++ /trunk/src/world_entities/power_ups/power_up.cc	(revision 7954)
@@ -201,34 +201,2 @@
 
 
-/********************************************************************************************
- NETWORK STUFF
- ********************************************************************************************/
-
-
-/**
- * data copied in data will bee sent to another host
- * @param data pointer to data
- * @param maxLength max length of data
- * @return the number of bytes writen
- */
-int PowerUp::readState( byte * data, int maxLength )
-{
-  SYNCHELP_WRITE_BEGIN();
-  SYNCHELP_WRITE_FKT( WorldEntity::readState, NWT_PU_WE_STATE );
-  return SYNCHELP_WRITE_N;
-}
-
-
-/**
- * Writes data from network containing information about the state
- * @param data pointer to data
- * @param length length of data
- * @param sender hostID of sender
- */
-int PowerUp::writeState( const byte * data, int length, int sender )
-{
-  SYNCHELP_READ_BEGIN();
-  SYNCHELP_READ_FKT( WorldEntity::writeState, NWT_PU_WE_STATE );
-  return SYNCHELP_READ_N;
-}
-
Index: /trunk/src/world_entities/power_ups/power_up.h
===================================================================
--- /trunk/src/world_entities/power_ups/power_up.h	(revision 7953)
+++ /trunk/src/world_entities/power_ups/power_up.h	(revision 7954)
@@ -34,7 +34,4 @@
   void setRespawnTime(const float respawn);
 
-  int       writeState(const byte* data, int length, int sender);
-  int       readState(byte* data, int maxLength );
-
 protected:
   PowerUp(float r, float g, float b);
Index: /trunk/src/world_entities/power_ups/turret_power_up.cc
===================================================================
--- /trunk/src/world_entities/power_ups/turret_power_up.cc	(revision 7953)
+++ /trunk/src/world_entities/power_ups/turret_power_up.cc	(revision 7954)
@@ -115,47 +115,2 @@
   glPopMatrix();
 }
-
-
-
-
-/********************************************************************************************
- NETWORK STUFF
- ********************************************************************************************/
-
-
-int TurretPowerUp::writeBytes( const byte * data, int length, int sender )
-{
-  setRequestedSync( false );
-  setIsOutOfSync( false );
-
-  SYNCHELP_READ_BEGIN();
-
-  SYNCHELP_READ_FKT( PowerUp::writeState, NWT_TPU_WE_STATE );
-
-  return SYNCHELP_READ_N;
-}
-
-
-int TurretPowerUp::readBytes( byte * data, int maxLength, int * reciever )
-{
-  if ( isOutOfSync() && !requestedSync() && this->getHostID()!=this->getOwner() )
-  {
-    (NetworkGameManager::getInstance())->sync( this->getUniqueID(), this->getOwner() );
-    setRequestedSync( true );
-  }
-
-  int rec = this->getRequestSync();
-  if ( rec > 0 )
-  {
-    *reciever = rec;
-
-    SYNCHELP_WRITE_BEGIN();
-
-    SYNCHELP_WRITE_FKT( PowerUp::readState, NWT_TPU_WE_STATE );
-
-    return SYNCHELP_WRITE_N;
-  }
-
-  *reciever = 0;
-  return 0;
-}
Index: /trunk/src/world_entities/power_ups/turret_power_up.h
===================================================================
--- /trunk/src/world_entities/power_ups/turret_power_up.h	(revision 7953)
+++ /trunk/src/world_entities/power_ups/turret_power_up.h	(revision 7954)
@@ -24,7 +24,4 @@
   virtual void draw() const;
 
-  virtual int writeBytes(const byte* data, int length, int sender);
-  virtual int readBytes(byte* data, int maxLength, int * reciever );
-
   private:
    void init();
Index: /trunk/src/world_entities/power_ups/weapon_power_up.cc
===================================================================
--- /trunk/src/world_entities/power_ups/weapon_power_up.cc	(revision 7953)
+++ /trunk/src/world_entities/power_ups/weapon_power_up.cc	(revision 7954)
@@ -103,43 +103,2 @@
 }
 
-int WeaponPowerUp::writeBytes( const byte * data, int length, int sender )
-{
-  setRequestedSync( false );
-  setIsOutOfSync( false );
-
-  SYNCHELP_READ_BEGIN();
-
-  SYNCHELP_READ_FKT( PowerUp::writeState, NWT_WPU_WE_STATE );
-
-  //TODO: sync weapon class ( see loadParams )
-
-  return SYNCHELP_READ_N;
-}
-
-
-
-int WeaponPowerUp::readBytes( byte * data, int maxLength, int * reciever )
-{
-  if ( isOutOfSync() && !requestedSync() && this->getHostID()!=this->getOwner() )
-  {
-    (NetworkGameManager::getInstance())->sync( this->getUniqueID(), this->getOwner() );
-    setRequestedSync( true );
-  }
-
-  int rec = this->getRequestSync();
-  if ( rec > 0 )
-  {
-    *reciever = rec;
-
-    SYNCHELP_WRITE_BEGIN();
-
-    SYNCHELP_WRITE_FKT( PowerUp::readState, NWT_WPU_WE_STATE );
-
-    //TODO: sync weapon class ( see loadParams )
-
-    return SYNCHELP_WRITE_N;
-  }
-
-  *reciever = 0;
-  return 0;
-}
Index: /trunk/src/world_entities/power_ups/weapon_power_up.h
===================================================================
--- /trunk/src/world_entities/power_ups/weapon_power_up.h	(revision 7953)
+++ /trunk/src/world_entities/power_ups/weapon_power_up.h	(revision 7954)
@@ -24,7 +24,4 @@
   void setWeaponClass(const std::string& name);
 
-  virtual int writeBytes(const byte* data, int length, int sender);
-  virtual int readBytes(byte* data, int maxLength, int * reciever );
-
   bool process(WeaponManager* manager);
 
Index: /trunk/src/world_entities/skybox.cc
===================================================================
--- /trunk/src/world_entities/skybox.cc	(revision 7953)
+++ /trunk/src/world_entities/skybox.cc	(revision 7954)
@@ -95,4 +95,7 @@
 {
   this->rebuild();
+  
+  textureName_handle = registerVarId( new SynchronizeableString( &textureName, &textureName, "textureName") );
+  size_handle = registerVarId( new SynchronizeableFloat( &size, &size, "size" ) );
 }
 
@@ -290,62 +293,21 @@
 }
 
-int SkyBox::writeBytes( const byte * data, int length, int sender )
-{
-  setRequestedSync( false );
-  setIsOutOfSync( false );
-
-  SYNCHELP_READ_BEGIN();
-
-  SYNCHELP_READ_FKT( WorldEntity::writeState, NWT_SB_WE_STATE );
-
-  SYNCHELP_READ_FLOAT( size, NWT_SB_SIZE );
-  if ( !this->textureName.empty() )
+void SkyBox::varChangeHandler( std::list< int > & id )
+{
+  bool somethinChanged = false;
+  
+  if ( std::find( id.begin(), id.end(), textureName_handle ) != id.end() )
   {
-    textureName = "";
+    somethinChanged = true;
+    setTexture( textureName );
   }
-  std::string texName;
-  SYNCHELP_READ_STRING( texName, NWT_SB_TEXTURENAME );
-
-  this->setSize( size );
-  this->setTextureAndType( texName, "jpg" );
-  this->rebuild();
-
-  return SYNCHELP_READ_N;
-}
-
-
-
-int SkyBox::readBytes( byte * data, int maxLength, int * reciever )
-{
-  if ( isOutOfSync() && !requestedSync() && this->getHostID()!=this->getOwner() )
+  
+  if ( std::find( id.begin(), id.end(), size_handle ) != id.end() )
   {
-    (NetworkGameManager::getInstance())->sync( this->getUniqueID(), this->getOwner() );
-    setRequestedSync( true );
+    somethinChanged = true;
   }
-
-  int rec = this->getRequestSync();
-  if ( rec > 0 )
-  {
-    *reciever = rec;
-
-    SYNCHELP_WRITE_BEGIN();
-
-    SYNCHELP_WRITE_FKT( WorldEntity::readState, NWT_SB_WE_STATE );
-
-    SYNCHELP_WRITE_FLOAT(this->size, NWT_SB_SIZE);
-    SYNCHELP_WRITE_STRING(this->textureName, NWT_SB_TEXTURENAME);
-
-    return SYNCHELP_WRITE_N;
-  }
-
-  *reciever = 0;
-  return 0;
-}
-
-void SkyBox::writeDebug( ) const
-{
-}
-
-void SkyBox::readDebug( ) const
-{
-}
+  
+  rebuild();
+  
+  WorldEntity::varChangeHandler( id );
+}
Index: /trunk/src/world_entities/skybox.h
===================================================================
--- /trunk/src/world_entities/skybox.h	(revision 7953)
+++ /trunk/src/world_entities/skybox.h	(revision 7954)
@@ -58,8 +58,5 @@
   static void disableCubeMap();
 
-  virtual int       writeBytes(const byte* data, int length, int sender);
-  virtual int       readBytes(byte* data, int maxLength, int * reciever);
-  virtual void      writeDebug() const;
-  virtual void      readDebug() const;
+  virtual void varChangeHandler( std::list<int> & id );
 
  private:
@@ -72,4 +69,7 @@
   float           textureSize;     //!< this is the length of a texture (assumes a square texture)
   std::string     textureName;     //!< Name of the Texture
+  
+  int textureName_handle;          //!< used to notify about changes of textureName
+  int size_handle;                 //!< used to notify about changes of size
 
 };
Index: /trunk/src/world_entities/space_ships/hover.cc
===================================================================
--- /trunk/src/world_entities/space_ships/hover.cc	(revision 7953)
+++ /trunk/src/world_entities/space_ships/hover.cc	(revision 7954)
@@ -175,4 +175,15 @@
   this->getWeaponManager().getFixedTarget()->setParent(&this->cameraNode);
   this->getWeaponManager().getFixedTarget()->setRelCoor(1000,0,0);
+  
+  // NETWORK THINGS
+  
+  registerVar( new SynchronizeableBool( &bForward, &bForward, "bForward", PERMISSION_OWNER ) );
+  registerVar( new SynchronizeableBool( &bBackward, &bBackward, "bBackward", PERMISSION_OWNER ) );
+  registerVar( new SynchronizeableBool( &bLeft, &bLeft, "bLeft", PERMISSION_OWNER ) );
+  registerVar( new SynchronizeableBool( &bRight, &bRight, "bRight", PERMISSION_OWNER ) );
+  registerVar( new SynchronizeableBool( &bAscend, &bAscend, "bAscend", PERMISSION_OWNER ) );
+  registerVar( new SynchronizeableBool( &bDescend, &bDescend, "bDescend", PERMISSION_OWNER ) );
+  
+  registerVar( new SynchronizeableFloat( &rotation, &rotation, "rotation", PERMISSION_OWNER ) );
 }
 
Index: /trunk/src/world_entities/space_ships/space_ship.cc
===================================================================
--- /trunk/src/world_entities/space_ships/space_ship.cc	(revision 7953)
+++ /trunk/src/world_entities/space_ships/space_ship.cc	(revision 7954)
@@ -93,19 +93,4 @@
   if (root != NULL)
     this->loadParams(root);
-  else
-  {
-    //this->loadModel("models/ships/reap_#.obj");
-    //TODO HACK this is only for network multiplayer games.
-    if( this->getOwner()%2 == 0)
-    {
-      this->loadModel("models/ships/reap_#.obj");
-      this->toList(OM_GROUP_00);
-    }
-    else
-    {
-      this->loadModel( "models/ships/fighter.obj" );
-      this->toList(OM_GROUP_01);
-    }
-  }
 
 }
@@ -234,5 +219,16 @@
   this->burstSystem->setColor(0.5, .5,.5,.8,.8);
   this->burstSystem->setColor(1.0, .8,.8,.8,.0);
-
+  
+  registerVar( new SynchronizeableVector( &velocity, &velocity, "velocity" ) );
+  registerVar( new SynchronizeableQuaternion( &mouseDir, &mouseDir, "mousedir", PERMISSION_OWNER ) );
+
+  registerVar( new SynchronizeableBool( &bUp, &bUp, "bUp", PERMISSION_OWNER ) );
+  registerVar( new SynchronizeableBool( &bDown, &bDown, "bDown", PERMISSION_OWNER ) );
+  registerVar( new SynchronizeableBool( &bLeft, &bLeft, "bLeft", PERMISSION_OWNER ) );
+  registerVar( new SynchronizeableBool( &bRight, &bRight, "bRight", PERMISSION_OWNER ) );
+  registerVar( new SynchronizeableBool( &bAscend, &bAscend, "bAscend", PERMISSION_OWNER ) );
+  registerVar( new SynchronizeableBool( &bDescend, &bDescend, "bDescend", PERMISSION_OWNER ) );
+  registerVar( new SynchronizeableBool( &bRollL, &bRollL, "bRollL", PERMISSION_OWNER ) );
+  registerVar( new SynchronizeableBool( &bRollR, &bRollR, "bRollR", PERMISSION_OWNER ) );
 }
 
@@ -306,6 +302,5 @@
     if ( isServer() )
     {
-      networkCollisionList.push_back( entity->getHealth() );
-      doCollideNetwork( entity->getHealth() );
+      //TODO handle this
     }
   }
@@ -349,5 +344,5 @@
 
   // spaceship controlled movement
-  if (this->getOwner() == this->getHostID())
+  //if (this->getOwner() == this->getHostID())
     this->calculateVelocity(time);
 
@@ -509,273 +504,4 @@
 
 
-#define MASK_bUp         1
-#define MASK_bDown       2
-#define MASK_bLeft       4
-#define MASK_bRight      8
-#define MASK_bAscend    16
-#define MASK_bDescend   32
-#define MASK_bRollL     64
-#define MASK_bRollR    128
-
-#define DATA_state       1
-#define DATA_flags       2
-#define DATA_mouse       3
-#define DATA_sync        4
-#define DATA_velocity    5
-#define DATA_playables   6
-#define DATA_collision   7
-
-int SpaceShip::writeBytes( const byte * data, int length, int sender )
-{
-  SYNCHELP_READ_BEGIN();
-
-  byte b;
-
-  while ( SYNCHELP_READ_REMAINING()>0 )
-  {
-    SYNCHELP_READ_BYTE( b, NWT_SS_B );
-
-    if ( b == DATA_state )
-    {
-      setRequestedSync( false );
-      setIsOutOfSync( false );
-      SYNCHELP_READ_FKT( WorldEntity::writeState, NWT_SS_WE_STATE );
-
-      continue;
-    }
-
-    if ( b == DATA_flags )
-    {
-      if ( this->getOwner() != this->getHostID() )
-      {
-        byte flags = 0;
-        SYNCHELP_READ_BYTE( flags, NWT_SS_FLAGS );
-
-        bUp = (flags & MASK_bUp) != 0;
-        bDown = (flags & MASK_bDown) != 0;
-        bLeft = (flags & MASK_bLeft) != 0;
-        bRight = (flags & MASK_bRight) != 0;
-        bAscend = (flags & MASK_bAscend) != 0;
-        bDescend = (flags & MASK_bDescend) != 0;
-        bRollL = (flags & MASK_bRollL) != 0;
-        bRollR = (flags & MASK_bRollR) != 0;
-
-      }
-      else
-        assert(false);
-
-      continue;
-    }
-
-    if ( b == DATA_mouse )
-    {
-      if ( this->getOwner() != this->getHostID() )
-      {
-        SYNCHELP_READ_FLOAT( mouseDir.w, NWT_SS_MOUSEDIRW );
-        SYNCHELP_READ_FLOAT( mouseDir.v.x, NWT_SS_MOUSEDIRX );
-        SYNCHELP_READ_FLOAT( mouseDir.v.y, NWT_SS_MOUSEDIRY );
-        SYNCHELP_READ_FLOAT( mouseDir.v.z, NWT_SS_MOUSEDIRZ );
-      }
-      else
-        assert(false);
-
-      continue;
-    }
-
-    if ( b == DATA_sync )
-    {
-      if ( this->getOwner() != this->getHostID() )
-      {
-        SYNCHELP_READ_FKT( PNode::writeSync, NWT_SS_PN_SYNC );
-      }
-      else
-        assert(false);
-
-      continue;
-    }
-
-    if ( b == DATA_velocity )
-    {
-      if ( this->getOwner() != this->getHostID() )
-      {
-        SYNCHELP_READ_FLOAT( velocity.x, NWT_SS_VELX );
-        SYNCHELP_READ_FLOAT( velocity.y, NWT_SS_VELY );
-        SYNCHELP_READ_FLOAT( velocity.z, NWT_SS_VELZ );
-      }
-      else
-        assert(false);
-
-      continue;
-    }
-
-    if ( b == DATA_playables )
-    {
-      if ( this->getOwner() != this->getHostID() )
-      {
-        SYNCHELP_READ_FKT( Playable::writeSync, NWT_SS_PL_SYNC );
-      }
-      else
-        assert(false);
-    }
-
-    if ( b == DATA_collision )
-    {
-      int n;
-      float energy;
-      SYNCHELP_READ_INT( n, NWT_SS_CO_N );
-
-      for ( int i = 0; i<n; i++ )
-      {
-        SYNCHELP_READ_FLOAT( energy, NWT_SS_CO_CLID );
-        doCollideNetwork( energy );
-      }
-    }
-  }
-
-  return SYNCHELP_READ_N;
-}
-
-
-
-int SpaceShip::readBytes( byte * data, int maxLength, int * reciever )
-{
-  SYNCHELP_WRITE_BEGIN();
-
-  if ( isOutOfSync() && !requestedSync() /*&& this->getHostID()!=this->getOwner()*/ )
-  {
-    (NetworkGameManager::getInstance())->sync( this->getUniqueID(), this->getOwner() );
-    setRequestedSync( true );
-    PRINTF(0)("REQUESTED STATE %d\n", this->getUniqueID());
-  }
-
-  int rec = this->getRequestSync();
-  if ( rec > 0 )
-  {
-    *reciever = rec;
-
-    PRINTF(0)("SEND STATE %d %d\n", this->getUniqueID(), rec);
-
-    SYNCHELP_WRITE_BYTE( (byte)DATA_state, NWT_SS_B );
-
-    SYNCHELP_WRITE_FKT( WorldEntity::readState, NWT_SS_WE_STATE );
-
-    return SYNCHELP_WRITE_N;
-  }
-
-  *reciever = 0 - this->getOwner();
-  //TODO: implement with SYNCHELP_WRITE_SENT()
-  bool sentSomething = false;
-
-  if ( PNode::needsReadSync() && ( this->getHostID()==0 || this->getOwner() == this->getHostID() ) )
-  {
-    PRINTF(0)("sending PNode::readSync\n");
-    SYNCHELP_WRITE_BYTE( DATA_sync, NWT_SS_B );
-    SYNCHELP_WRITE_FKT( PNode::readSync, NWT_SS_PN_SYNC );
-    sentSomething = true;
-  }
-
-  if ( this->getHostID()==0 || this->getHostID()==this->getOwner() )
-  {
-    byte mask = 0;
-
-    if ( bUp )
-      mask |= MASK_bUp;
-    if ( bDown )
-      mask |= MASK_bDown;
-    if ( bLeft )
-      mask |= MASK_bLeft;
-    if ( bRight )
-      mask |= MASK_bRight;
-    if ( bAscend )
-      mask |= MASK_bAscend;
-    if ( bRollL )
-      mask |= MASK_bRollL;
-    if ( bRollR )
-      mask |= MASK_bRollR;
-
-
-    if ( mask != oldMask )
-    {
-      oldMask = mask;
-      PRINTF(0)("sending mask\n");
-      sentSomething = true;
-      SYNCHELP_WRITE_BYTE( DATA_flags, NWT_SS_B );
-      SYNCHELP_WRITE_BYTE( mask, NWT_SS_FLAGS );
-    }
-#define __OFFSET_MDIR_W 0.01
-#define __OFFSET_MDIR_V 0.01
-    if ( fabs( oldMouseDir.w - mouseDir.w ) > __OFFSET_MDIR_W ||
-         fabs( oldMouseDir.v.x - mouseDir.v.x ) > __OFFSET_MDIR_V ||
-         fabs( oldMouseDir.v.y - mouseDir.v.y ) > __OFFSET_MDIR_V ||
-         fabs( oldMouseDir.v.z - mouseDir.v.z ) > __OFFSET_MDIR_V )
-    {
-      oldMouseDir = mouseDir;
-
-      SYNCHELP_WRITE_BYTE( DATA_mouse, NWT_SS_B );
-      PRINTF(0)("SENDING mousedir\n");
-      sentSomething = true;
-      SYNCHELP_WRITE_FLOAT( mouseDir.w, NWT_SS_MOUSEDIRW );
-      SYNCHELP_WRITE_FLOAT( mouseDir.v.x, NWT_SS_MOUSEDIRX );
-      SYNCHELP_WRITE_FLOAT( mouseDir.v.y, NWT_SS_MOUSEDIRY );
-      SYNCHELP_WRITE_FLOAT( mouseDir.v.z, NWT_SS_MOUSEDIRZ );
-    }
-#define __OFFSET_VEL 0.05
-    if ( fabs( oldVelocity.x - velocity.x ) > __OFFSET_VEL*fabs(oldVelocity.x)+0.1 ||
-         fabs( oldVelocity.y - velocity.y ) > __OFFSET_VEL*fabs(oldVelocity.y)+0.1 ||
-         fabs( oldVelocity.z - velocity.z ) > __OFFSET_VEL*fabs(oldVelocity.z)+0.1 )
-    {
-      oldVelocity.x = velocity.x;
-      oldVelocity.y = velocity.y;
-      oldVelocity.z = velocity.z;
-      PRINTF(0)("SENDING velocity\n");
-      sentSomething = true;
-      SYNCHELP_WRITE_BYTE( DATA_velocity, NWT_SS_B );
-      SYNCHELP_WRITE_FLOAT( velocity.x, NWT_SS_VELX );
-      SYNCHELP_WRITE_FLOAT( velocity.y, NWT_SS_VELY );
-      SYNCHELP_WRITE_FLOAT( velocity.z, NWT_SS_VELZ );
-    }
-
-    while ( Playable::needsReadSync() )
-    {
-      sentSomething = true;
-      PRINTF(0)("SYNCHELP_WRITE_FKT( Playable::readSync, NWT_SS_PL_SYNC )\n");
-      SYNCHELP_WRITE_BYTE( DATA_playables, NWT_SS_B );
-      SYNCHELP_WRITE_FKT( Playable::readSync, NWT_SS_PL_SYNC );
-    }
-
-  }
-
-  if ( !sentSomething )
-  {
-    *reciever = 0;
-
-    if ( networkCollisionList.size()>0 )
-    {
-      SYNCHELP_WRITE_BYTE( DATA_collision, NWT_SS_B );
-
-      SYNCHELP_WRITE_INT( networkCollisionList.size(), NWT_SS_CO_N );
-
-      for ( std::list<float>::iterator it = networkCollisionList.begin(); it!=networkCollisionList.end(); it++ )
-      {
-        SYNCHELP_WRITE_FLOAT( *it, NWT_SS_CO_CLID );
-      }
-
-      networkCollisionList.clear();
-    }
-  }
-
-  return SYNCHELP_WRITE_N;
-}
-
-
-void SpaceShip::doCollideNetwork( float energy )
-{
-  this->decreaseHealth( energy );
-  if( this->getHealth() <= 0)
-  {
-    this->die();
-  }
-}
-
-
-
+
+
Index: /trunk/src/world_entities/space_ships/space_ship.h
===================================================================
--- /trunk/src/world_entities/space_ships/space_ship.h	(revision 7953)
+++ /trunk/src/world_entities/space_ships/space_ship.h	(revision 7954)
@@ -43,11 +43,4 @@
     virtual void process(const Event &event);
 
-    virtual int       writeBytes(const byte* data, int length, int sender);
-    virtual int       readBytes(byte* data, int maxLength, int * reciever);
-
-    //HACK HACK HACK HACK make this private or remove it
-    void doCollideNetwork( float energy );
-    std::list<float>        networkCollisionList;
-
   private:
     void init();
Index: /trunk/src/world_entities/terrain.cc
===================================================================
--- /trunk/src/world_entities/terrain.cc	(revision 7953)
+++ /trunk/src/world_entities/terrain.cc	(revision 7954)
@@ -423,44 +423,4 @@
 }
 
-int Terrain::writeBytes( const byte * data, int length, int sender )
-{
-  setRequestedSync( false );
-  setIsOutOfSync( false );
-
-  SYNCHELP_READ_BEGIN();
-  SYNCHELP_READ_FKT( WorldEntity::writeState, NWT_TER_WE_STATE );
-
-  return SYNCHELP_READ_N;
-}
-
-int Terrain::readBytes( byte * data, int maxLength, int * reciever )
-{
-  if ( isOutOfSync() && !requestedSync() && this->getHostID()!=this->getOwner() )
-  {
-    (NetworkGameManager::getInstance())->sync( this->getUniqueID(), this->getOwner() );
-    setRequestedSync( true );
-  }
-
-  int rec = this->getRequestSync();
-  if ( rec > 0 )
-  {
-    *reciever = rec;
-
-    SYNCHELP_WRITE_BEGIN();
-    SYNCHELP_WRITE_FKT( WorldEntity::readState, NWT_TER_WE_STATE );
-    return SYNCHELP_WRITE_N;
-
-  }
-
-  *reciever = 0;
-  return 0;
-}
-
-void Terrain::writeDebug( ) const
-  {}
-
-void Terrain::readDebug( ) const
-  {}
-
 float Terrain::getHeight(float x, float y)
 {
Index: /trunk/src/world_entities/terrain.h
===================================================================
--- /trunk/src/world_entities/terrain.h	(revision 7953)
+++ /trunk/src/world_entities/terrain.h	(revision 7954)
@@ -33,9 +33,4 @@
   virtual ~Terrain();
 
-  virtual int       writeBytes(const byte* data, int length, int sender);
-  virtual int       readBytes(byte* data, int maxLength, int * reciever);
-  virtual void      writeDebug() const;
-  virtual void      readDebug() const;
-
   void init();
   virtual void loadParams(const TiXmlElement* root);
